<template>
	<div class="menu">
		<car-part-selector
			v-for="input in inputs"
			v-on:change-body="onBodyChange"
			v-on:change-wheel="onWheelChange"
			:config="input.config"
			:key="input.id"
			:id="input.id"
			:input="input.input"
		/>
	</div>
</template>

<script>
// Classes
import CarCustomisationFloor from "../../floors/CarCustomisationFloor.js"

// Components
import CarPartSelector from "../components/CarPartSelector.vue"

// Constants
import * as TOWER from "../../constants/tower.js"

export default {
	beforeDestroy () {
		UI.off("PRESS_BACK", this.goBack)
	},
	components: { CarPartSelector },
	computed: {
		inputs () {
			return Input.list.map((input, key) => {
				return {
					config: this.data[key],
					id: key,
					input,
				}
			})
		}
	},
	data () {
		return {
			data: Settings.get("CAR_CONFIGURATION"),
			mounted: false
		}
	},
	destroyed () {
		this.mounted = false
	},
	methods: {
		goBack () {
			UI.emit("GO_BACK")
		},
		onBodyChange (id, value) {
			const data = Settings.get("CAR_CONFIGURATION")
			data[id].body = value
			Settings.set("CAR_CONFIGURATION", data)
			this.data = data
		},
		onWheelChange (id, value) {
			const data = Settings.get("CAR_CONFIGURATION")
			data[id].wheel = value
			Settings.set("CAR_CONFIGURATION", data)
			this.data = data
		}
	},
	mounted () {
		this.mounted = true

		// Update tower
		Tower.goToFloor(CarCustomisationFloor, "down", () => {
			Tower.setState(TOWER.STATE_ARENA_DEFAULT)
		})

		UI.on("PRESS_BACK", this.goBack)
	},
	name: "car-customisation"
}
</script>

<style lang="less" scoped>
</style>